/**
* PeerTube
* # Introduction  The PeerTube API is built on HTTP(S) and is RESTful. You can use your favorite HTTP/REST library for your programming language to use PeerTube. The spec API is fully compatible with [openapi-generator](https://github.com/OpenAPITools/openapi-generator/wiki/API-client-generator-HOWTO) which generates a client SDK in the language of your choice - we generate some client SDKs automatically:  - [Python](https://framagit.org/framasoft/peertube/clients/python) - [Go](https://framagit.org/framasoft/peertube/clients/go) - [Kotlin](https://framagit.org/framasoft/peertube/clients/kotlin)  See the [Quick Start guide](https://docs.joinpeertube.org/#/api-rest-getting-started) so you can play with the PeerTube API.  # Authentication  When you sign up for an account, you are given the possibility to generate sessions, and authenticate using this session token. One session token can currently be used at a time.  ## Roles  Accounts are given permissions based on their role. There are three roles on PeerTube: Administrator, Moderator, and User. See the [roles guide](https://docs.joinpeertube.org/#/admin-managing-users?id=roles) for a detail of their permissions.  # Errors  The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be JSON in the following format.  ``` {   \"code\": \"unauthorized_request\", // example inner error code   \"error\": \"Token is invalid.\" // example exposed error message } ``` 
*
* The version of the OpenAPI document: 2.4.0
* 
*
* NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
* https://openapi-generator.tech
* Do not edit the class manually.
*/
package org.peertube.client.models

import org.peertube.client.models.AbusesAccount
import org.peertube.client.models.AbusesComment
import org.peertube.client.models.AbusesVideo

import com.squareup.moshi.Json

/**
 * 
 * @param reason Reason why the user reports this video
 * @param predefinedReasons Reason categories that help triage reports
 * @param video 
 * @param comment 
 * @param account 
 */

data class InlineObject10 (
    /* Reason why the user reports this video */
    @Json(name = "reason")
    val reason: kotlin.String,
    /* Reason categories that help triage reports */
    @Json(name = "predefinedReasons")
    val predefinedReasons: kotlin.collections.List<InlineObject10.PredefinedReasons>? = null,
    @Json(name = "video")
    val video: AbusesVideo? = null,
    @Json(name = "comment")
    val comment: AbusesComment? = null,
    @Json(name = "account")
    val account: AbusesAccount? = null
) {

    /**
    * Reason categories that help triage reports
    * Values: violentOrAbusive,hatefulOrAbusive,spamOrMisleading,privacy,rights,serverRules,thumbnails,captions
    */
    
    enum class PredefinedReasons(val value: kotlin.String){
        @Json(name = "violentOrAbusive") violentOrAbusive("violentOrAbusive"),
        @Json(name = "hatefulOrAbusive") hatefulOrAbusive("hatefulOrAbusive"),
        @Json(name = "spamOrMisleading") spamOrMisleading("spamOrMisleading"),
        @Json(name = "privacy") privacy("privacy"),
        @Json(name = "rights") rights("rights"),
        @Json(name = "serverRules") serverRules("serverRules"),
        @Json(name = "thumbnails") thumbnails("thumbnails"),
        @Json(name = "captions") captions("captions");
    }
}

